;; maxima_asdf.lisp -- ASDF component type for Maxima
;; copyright 2015 by Robert Dodier
;; I release this work under terms of the GNU General Public License

(require 'asdf)

(in-package :asdf)

(defclass maxima-file (source-file)
  ((type :initform "mac")))

(defmethod perform ((o load-source-op) (c maxima-file))
  (let ((source-file (first (input-files o c))))
    (maxima::$load source-file)))

(defmethod perform ((o load-op) (c maxima-file))
  (let ((source-file (first (input-files o c))))
    (load source-file)))

(defmethod output-files ((o compile-op) (c maxima-file))
  (let
    ((maxima-version (concatenate 'string "maxima-" maxima::*autoconf-version*))
     (system-name (component-name (component-system c)))
     (component-name (component-name c)))
    (list (make-pathname :directory (list :relative maxima-version system-name) :name component-name))))

(defmethod perform ((o compile-op) (c maxima-file))
  (let*
    ((source-file (first (input-files o c)))
     (output-file (first (output-files o c)))
     (x (maxima::$translate_file source-file output-file)))
    (compile-file* (third x))))

(defun maxima::$asdf_load (name)
  (asdf:load-system name))

(defun maxima::$asdf_compile (name)
  (asdf:compile-system name))

(defun maxima::$asdf_load_source (name)
  (asdf:oos 'asdf:load-source-op name))
